USE cubeoffice
go

drop table abteilung
go
drop table adresse
go
drop table akte
go
drop table banken
go
drop table bankverbindung
go
drop table benutzer
go
drop table branche
go
drop table eigeneFelder
go
drop table eigeneFelderInhalte
go
drop table eigenkonten
go
drop table firma
go
drop table gespraecheNotizen
go
drop table kategorie
go
drop table kennzeichen
go
drop table kennzeichenInhalte
go
drop table kommart
go
drop table kommunikation
go
drop table laender
go
drop table person
go
drop table protokollZahlungsverkehr
go
drop table schluessel
go
drop table voreinstellungen
go
drop table zahlungsbedingungen
go

CREATE TABLE                  abteilung
(
    abteilungID               int,
    firmaID                   int,
    name                      varchar(20),
    langform                  varchar(50)  NULL
)
go

CREATE TABLE                  adresse
(
    adresseID                 int,
    bezeichnung               varchar(50)  NULL,
    postfach                  varchar(20)  NULL,
    plzpostfach               varchar(10)  NULL,
    strasse                   varchar(50)  NULL,
    ort                       varchar(50)  NULL,
    plzort                    varchar(10)  NULL,
    benutzePostfach           tinyint  NULL
)
go

CREATE TABLE                  akte
(
    fpID                      int,
    filename                  varchar(255),
    anzeige                   tinyint  NULL
)
go

CREATE TABLE                  banken
(
    blz                       varchar(20),
    bank                      varchar(50)  NULL,
    ort                       varchar(50)  NULL
)
go

CREATE TABLE                  bankverbindung
(
    bankverbindungID          int,
    fpID                      int,
    konto                     varchar(25),
    blz                       varchar(20),
    bank                      varchar(50)  NULL,
    ort                       varchar(50)  NULL,
    zuletztbenutzteBank       tinyint  NULL
)
go

CREATE TABLE                  benutzer
(
    benutzerID                int,
    namelang                  varchar(255),
    namekurz                  varchar(20),
    passwort                  varchar(255)  NULL,
    zugriff                   int
)
go

CREATE TABLE                  branche
(
    brancheID                 int,
    beschreibung              varchar(25)  NULL
)
go


CREATE TABLE                  eigeneFelder
(
    ufID                      int,
    bezeichnung               varchar(30)  NULL,
    bildschirmPosition        tinyint  NULL,
    zuordnung                 tinyint
)
go

CREATE TABLE                  eigeneFelderInhalte
(
    fpID                      int,
    ufID                      int,
    inhalt                    varchar(50)  NULL
)
go

CREATE TABLE                  eigenkonten
(
    eigenkontenID             int,
    kurzbezeichnung           varchar(50),
    kontoinhaber              varchar(255),
    konto                     varchar(25),
    blz                       varchar(20),
    kontoart                  tinyint  NULL,
    bank                      varchar(50)  NULL,
    ort                       varchar(50)  NULL,
    unterschrift              image  NULL
)
go

CREATE TABLE                  firma
(
    firmaID                   int,
    kundennummer              varchar(30)  NULL,
    firmenName                varchar(100),
    mailingsperre             tinyint  NULL,
    brancheID                 int  NULL,
    adresseID                 int,
    alternatAdresse1ID        int  NULL,
    prioritaet                tinyint  NULL,
    zahlungsbedID             int  NULL,
    landID                    int  NULL,
    kategoriematrix           tinyint  NULL,
    rabatt                    float  NULL,
    rabattmax                 float  NULL,
    kreditlimit               float  NULL,
    bemerkungRTF              image  NULL,
    bemerkungASCII            text  NULL,
    sprache                   image  NULL,
    erstelltAm                datetime  NULL,
    erstelltVonID             int  NULL,
    geaendertAm               datetime  NULL,
    geaendertVonID            int  NULL,
    umsatzGesamt              money  NULL,
    umsatzLfdJahr             money  NULL
)
go

CREATE TABLE                  gespraecheNotizen
(
    gespraecheNotizenID       int,
    fpID                      int,
    betreff                   varchar(50)  NULL,
    inhaltASCII               text  NULL,
    inhaltRTF                 image  NULL,
    sprache                   image  NULL,
    erstelltAm                datetime  NULL,
    erstelltVonID             int  NULL,
    geaendertAm               datetime  NULL,
    geaendertVonID            int  NULL,
    anlass                    tinyint  NULL,
    erledigt                  tinyint  NULL,
    aktion                    tinyint  NULL,
    erledigenBis              datetime  NULL
)
go

CREATE TABLE                  kategorie
(
    katID                     int  NULL,
    kat1                      varchar(30)  NULL,
    kat2                      varchar(30)  NULL,
    kat3                      varchar(30)  NULL,
    kat4                      varchar(30)  NULL,
    kat5                      varchar(30)  NULL,
    kat6                      varchar(30)  NULL
)
go

CREATE TABLE                  kennzeichen
(
    kennzeichenID             int,
    name                      varchar(25)  NULL
)
go

CREATE TABLE                  kennzeichenInhalte
(
    fpID                      int,
    kennzeichenID             int
)
go

CREATE TABLE                  kommart
(
    artID                     tinyint,
    bezeichnung               varchar(20)
)
go

CREATE TABLE                  kommunikation
(
    kommID                    int,
    fpID                      int,
    artID                     tinyint  NULL,
    verbindung                varchar(50)  NULL,
    bemerkung                 varchar(50)  NULL,
    position                  int  NULL
)
go

CREATE TABLE                  laender
(
    landID                    int  NULL,
    lshort                    char(4)  NULL,
    llong                     varchar(20)  NULL
)
go

CREATE TABLE                  person
(
    personID                  int,
    nachname                  varchar(25),
    vorname                   varchar(25)  NULL,
    geschlecht                tinyint  NULL,
    titel                     varchar(20)  NULL,
    geburtsdatum              varchar(10)  NULL,
    abteilungID               int  NULL,
    brancheID                 int  NULL,
    firmaID                   int  NULL,
    adresseID                 int  NULL,
    alternatAdresse1ID        int  NULL,
    privatAdresseID           int  NULL,
    postFirmaPrivat           tinyint  NULL,
    mailingsperre             tinyint  NULL,
    prioritaet                tinyint  NULL,
    zahlungsbedID             int  NULL,
    landID                    int  NULL,
    kategoriematrix           tinyint  NULL,
    position                  varchar(25)  NULL,
    rabatt                    float  NULL,
    rabattmax                 float  NULL,
    kreditlimit               float  NULL,
    erstelltAm                datetime  NULL,
    erstelltVonID             int  NULL,
    bemerkungRTF              image  NULL,
    bemerkungASCII            text  NULL,
    sprache                   image  NULL,
    geaendertAm               datetime  NULL,
    geaendertVonID            int  NULL,
    kundennummer              varchar(30)  NULL
)
go

CREATE TABLE                  protokollZahlungsverkehr
(
    protokollID               int,
    erstelltAm                datetime  NULL,
    erstelltVonID             int,
    empf_bank                 varchar(50)  NULL,
    empf_blz                  varchar(20)  NULL,
    empf_kontonr              varchar(20)  NULL,
    empfaenger                varchar(255)  NULL,
    eigenkontenID             int,
    verwendungszweck          varchar(255)  NULL,
    betrag                    varchar(20)  NULL,
    zahlungsart               tinyint  NULL,
    bemerkung                 text  NULL,
    lfdFormularNummer         varchar(20)  NULL,
    bereitsausgefuehrt        tinyint  NULL
)
go

/*
Diese Tabelle dient dazu, fr die Tabellen, die einen eindeutigen
Schlssel bentigen, diesen hier zu speichern.
Die Tabelle ist beliebig ausbaubar, die zugehrige Klasse "Unique_Key"
erstellt fr nicht bekannte Tabellen automatisch einen Eintrag.
*/

CREATE TABLE                  schluessel
(
    tabelle                   varchar(100),
    max_schluessel            int
)
go

CREATE TABLE                  voreinstellungen
(
    voreinstellungID          int,
    benutzerID                int,
    bezeichnung               varchar(255)  NULL,
    inhalt                    text  NULL
)
go

CREATE TABLE                  zahlungsbedingungen
(
    zahlungsbedID             int,
    skontotage                int  NULL,
    skonto                    float  NULL,
    nettotage                 int  NULL
)
go


exec sp_primarykey kategorie, katID
exec sp_primarykey gespraecheNotizen, gespraecheNotizenID
exec sp_primarykey protokollZahlungsverkehr, protokollID
exec sp_primarykey adresse, adresseID
exec sp_primarykey akte, fpID
exec sp_primarykey laender, landID
exec sp_primarykey firma, firmaID
exec sp_primarykey branche, brancheID
exec sp_primarykey voreinstellungen, voreinstellungID
exec sp_primarykey zahlungsbedingungen, zahlungsbedID
exec sp_primarykey benutzer, benutzerID
exec sp_primarykey eigenkonten, eigenkontenID
exec sp_primarykey eigeneFelderInhalte, fpID, ufID
exec sp_primarykey banken, blz
exec sp_primarykey bankverbindung, bankverbindungID
exec sp_primarykey schluessel, tabelle
exec sp_primarykey kennzeichen, kennzeichenID
exec sp_primarykey kommart, artID
exec sp_primarykey person, personID
exec sp_primarykey abteilung, abteilungID
exec sp_primarykey kennzeichenInhalte, fpID, kennzeichenID
exec sp_primarykey eigeneFelder, ufID
go


exec sp_foreignkey protokollZahlungsverkehr, eigenkonten, eigenkontenID
exec sp_foreignkey firma, branche, brancheID
exec sp_foreignkey firma, laender, landID
exec sp_foreignkey firma, zahlungsbedingungen, zahlungsbedID
exec sp_foreignkey firma, adresse, adresseID
exec sp_foreignkey voreinstellungen, benutzer, benutzerID
exec sp_foreignkey eigenkonten, banken, blz
exec sp_foreignkey eigeneFelderInhalte, eigeneFelder, ufID
exec sp_foreignkey bankverbindung, banken, blz
exec sp_foreignkey person, branche, brancheID
exec sp_foreignkey person, firma, firmaID
exec sp_foreignkey person, laender, landID
exec sp_foreignkey person, abteilung, abteilungID
exec sp_foreignkey person, zahlungsbedingungen, zahlungsbedID
exec sp_foreignkey person, adresse, adresseID
exec sp_foreignkey abteilung, firma, firmaID
exec sp_foreignkey kommunikation, kommart, artID
go

exec sp_commonkey gespraecheNotizen, firma, fpID, firmaID
exec sp_commonkey gespraecheNotizen, benutzer, geaendertVonID, benutzerID
exec sp_commonkey gespraecheNotizen, benutzer, erstelltVonID, benutzerID
exec sp_commonkey gespraecheNotizen, person, fpID, personID
exec sp_commonkey protokollZahlungsverkehr, benutzer, erstelltVonID, benutzerID
exec sp_commonkey akte, firma, fpID, firmaID
exec sp_commonkey akte, person, fpID, personID
exec sp_commonkey firma, bankverbindung, firmaID, fpID
exec sp_commonkey firma, kommunikation, firmaID, fpID
exec sp_commonkey benutzer, firma, benutzerID, erstelltVonID
exec sp_commonkey benutzer, firma, benutzerID, geaendertVonID
exec sp_commonkey eigeneFelderInhalte, firma, fpID, firmaID
exec sp_commonkey person, bankverbindung, personID, fpID
exec sp_commonkey person, benutzer, erstelltVonID, benutzerID
exec sp_commonkey person, benutzer, geaendertVonID, benutzerID
exec sp_commonkey person, eigeneFelderInhalte, personID, fpID
exec sp_commonkey person, kennzeichenInhalte, personID, fpID
exec sp_commonkey person, person, privatAdresseID, privatAdresseID
exec sp_commonkey person, adresse, privatAdresseID, adresseID
exec sp_commonkey kommunikation, person, fpID, personID
exec sp_commonkey kennzeichenInhalte, kennzeichen, kennzeichenID, kennzeichenID
exec sp_commonkey kennzeichenInhalte, firma, fpID, firmaID
go




create unique clustered index firmaidind
on firma (firmaID)
go
create unique clustered index personidind
on person (personID)
go
create unique clustered index adresseidind
on adresse (adresseID)
go
create unique clustered index kommunikationidind
on kommunikation (kommID)
go
create nonclustered index firmanameind
on firma (firmenName)
go
create nonclustered index strasseind
on adresse (strasse)
go
create nonclustered index personind
on person (nachname)


go
grant all on firma to public
go
grant all on person to public
go
grant all on adresse to public
go
grant all on kommunikation to public
go
grant all on kommart to public
go
grant all on kategorie to public
go

