
/* 
   Autor :   Ulrich Bortfeld
   Datum :   Thu Aug 11 13:34:10 MET DST 1994
   Bemerkung :   
             Dieses Script erzeugt die Tabellen fr die CubeSoftware
             Anwendung auf einem Sybase sql Datenbank Server 
*/


use cubeoffice
go

drop table sw_produkt
go

create table sw_produkt (
	sw_produkt_id				int ,
	sw_produkt_name				varchar(30)  NULL ,
	sw_produkt_icon				image  NULL ,
	sw_produkt_beschreibung		image  NULL ,
	sw_produkt_datum			datetime NULL ,
	sw_hersteller_id			int NULL
) 
go

create trigger del_sw_hersteller
on sw_hersteller
for delete
as
delete sw_produkt
from sw_produkt, deleted
where sw_produkt.sw_hersteller_id = deleted.sw_hersteller_id
go

create table sw_lizenz (
	sw_lizenz_id				int ,
	sw_produkt_id				int ,
	sw_fp_id					int ,
	sw_lizenz_typ				int NULL ,
	sw_lizenz_benutzer			int NULL ,
	sw_lizenz_datum				datetime NULL ,
	sw_lizenz_serien_nr			varchar(15) NULL ,
	sw_lizenz_schluessel_nr		varchar(30) NULL ,
	sw_lizenz_bemerkung			varchar(60) NULL
)
go

create trigger del_sw_produkt
on sw_produkt
for delete
as
delete sw_lizenz
from sw_lizenz, deleted
where sw_lizenz.sw_produkt_id = deleted.sw_produkt_id
go


create table sw_lieferant (
	sw_lieferant_id				int ,
	sw_lieferant_name			varchar(30) NULL ,
)
go

create table sw_hersteller (
	sw_hersteller_id			int ,
	sw_hersteller_name			varchar(30) NULL 
)
go




